

# DeleteResourcePolicyStatement


Deletes a policy statement from a resource policy. If you delete the last statement from a policy, the policy is deleted. If you specify a statement ID that doesn't exist in the policy, or if the bot or bot alias doesn't have a policy attached, Amazon Lex returns an exception.

You need to add the `DeleteResourcePolicy` or `UpdateResourcePolicy` action to the bot role in order to call the API.

## Request Syntax


```
DELETE /policy/resourceArn/statements/statementId/?expectedRevisionId=expectedRevisionId HTTP/1.1
```

## URI Request Parameters


The request uses the following URI parameters.

 ** [expectedRevisionId](#API_DeleteResourcePolicyStatement_RequestSyntax) **   <a name="lexv2-DeleteResourcePolicyStatement-request-uri-expectedRevisionId"></a>
The identifier of the revision of the policy to delete the statement from. If this revision ID doesn't match the current revision ID, Amazon Lex throws an exception.  
If you don't specify a revision, Amazon Lex removes the current contents of the statement.   
Length Constraints: Minimum length of 1. Maximum length of 5.  
Pattern: `^[0-9]+$` 

 ** [resourceArn](#API_DeleteResourcePolicyStatement_RequestSyntax) **   <a name="lexv2-DeleteResourcePolicyStatement-request-uri-resourceArn"></a>
The Amazon Resource Name (ARN) of the bot or bot alias that the resource policy is attached to.  
Length Constraints: Minimum length of 1. Maximum length of 1011.  
Required: Yes

 ** [statementId](#API_DeleteResourcePolicyStatement_RequestSyntax) **   <a name="lexv2-DeleteResourcePolicyStatement-request-uri-statementId"></a>
The name of the statement (SID) to delete from the policy.  
Length Constraints: Minimum length of 1. Maximum length of 100.  
Pattern: `^([0-9a-zA-Z][_-]?){1,100}$`   
Required: Yes

## Request Body


The request does not have a request body.

## Response Syntax


```
HTTP/1.1 204
Content-type: application/json

{
   "resourceArn": "string",
   "revisionId": "string"
}
```

## Response Elements


If the action is successful, the service sends back an HTTP 204 response.

The following data is returned in JSON format by the service.

 ** [resourceArn](#API_DeleteResourcePolicyStatement_ResponseSyntax) **   <a name="lexv2-DeleteResourcePolicyStatement-response-resourceArn"></a>
The Amazon Resource Name (ARN) of the bot or bot alias that the resource policy statement was removed from.  
Type: String  
Length Constraints: Minimum length of 1. Maximum length of 1011.

 ** [revisionId](#API_DeleteResourcePolicyStatement_ResponseSyntax) **   <a name="lexv2-DeleteResourcePolicyStatement-response-revisionId"></a>
The current revision of the resource policy. Use the revision ID to make sure that you are updating the most current version of a resource policy when you add a policy statement to a resource, delete a resource, or update a resource.  
Type: String  
Length Constraints: Minimum length of 1. Maximum length of 5.  
Pattern: `^[0-9]+$` 

## Errors


For information about the errors that are common to all actions, see [Common Error Types](CommonErrors.md).

 ** InternalServerException **   
The service encountered an unexpected condition. Try your request again.  
HTTP Status Code: 500

 ** PreconditionFailedException **   
Your request couldn't be completed because one or more request fields aren't valid. Check the fields in your request and try again.  
HTTP Status Code: 412

 ** ResourceNotFoundException **   
You asked to describe a resource that doesn't exist. Check the resource that you are requesting and try again.  
HTTP Status Code: 404

 ** ThrottlingException **   
Your request rate is too high. Reduce the frequency of requests.    
 ** retryAfterSeconds **   
The number of seconds after which the user can invoke the API again.
HTTP Status Code: 429

## See Also


For more information about using this API in one of the language-specific AWS SDKs, see the following:
+  [AWS Command Line Interface V2](https://docs.aws.amazon.com/goto/cli2/models.lex.v2-2020-08-07/DeleteResourcePolicyStatement) 
+  [AWS SDK for .NET V4](https://docs.aws.amazon.com/goto/DotNetSDKV4/models.lex.v2-2020-08-07/DeleteResourcePolicyStatement) 
+  [AWS SDK for C\$1\$1](https://docs.aws.amazon.com/goto/SdkForCpp/models.lex.v2-2020-08-07/DeleteResourcePolicyStatement) 
+  [AWS SDK for Go v2](https://docs.aws.amazon.com/goto/SdkForGoV2/models.lex.v2-2020-08-07/DeleteResourcePolicyStatement) 
+  [AWS SDK for Java V2](https://docs.aws.amazon.com/goto/SdkForJavaV2/models.lex.v2-2020-08-07/DeleteResourcePolicyStatement) 
+  [AWS SDK for JavaScript V3](https://docs.aws.amazon.com/goto/SdkForJavaScriptV3/models.lex.v2-2020-08-07/DeleteResourcePolicyStatement) 
+  [AWS SDK for Kotlin](https://docs.aws.amazon.com/goto/SdkForKotlin/models.lex.v2-2020-08-07/DeleteResourcePolicyStatement) 
+  [AWS SDK for PHP V3](https://docs.aws.amazon.com/goto/SdkForPHPV3/models.lex.v2-2020-08-07/DeleteResourcePolicyStatement) 
+  [AWS SDK for Python](https://docs.aws.amazon.com/goto/boto3/models.lex.v2-2020-08-07/DeleteResourcePolicyStatement) 
+  [AWS SDK for Ruby V3](https://docs.aws.amazon.com/goto/SdkForRubyV3/models.lex.v2-2020-08-07/DeleteResourcePolicyStatement) 